summaryrefslogtreecommitdiff
path: root/testing/docker
diff options
context:
space:
mode:
Diffstat (limited to 'testing/docker')
-rw-r--r--testing/docker/alpine3.8/EXPERIMENTAL11
-rw-r--r--testing/docker/centos6/Dockerfile3
-rw-r--r--testing/docker/centos7/Dockerfile4
-rwxr-xr-xtesting/docker/dmgr.sh24
-rw-r--r--testing/docker/fedora29/Dockerfile (renamed from testing/docker/fedora28/Dockerfile)4
-rw-r--r--testing/docker/mint19-amd64/Dockerfile2
6 files changed, 41 insertions, 7 deletions
diff --git a/testing/docker/alpine3.8/EXPERIMENTAL b/testing/docker/alpine3.8/EXPERIMENTAL
new file mode 100644
index 0000000..4d4d6d7
--- /dev/null
+++ b/testing/docker/alpine3.8/EXPERIMENTAL
@@ -0,0 +1,11 @@
+Support for Alpine Linux as a build or host platform is EXPERIMENTAL. Some of
+the packages try to compile binaries for the build or the machine and fail
+because they expect certain GLIBC-specific types, etc: Alpine Linux does not
+use GNU libc, it uses musl.
+
+Only the following bug reports will be looked into:
+- A sample configuration used to build successfully and no longer does. Identify
+the commit ID that builds successfully for you.
+- A pull request that fixes the build for any sample on the Alpine Linux.
+
+All other bug reports against Alpine as a build/host will be summarily closed.
diff --git a/testing/docker/centos6/Dockerfile b/testing/docker/centos6/Dockerfile
index c3a0da8..6c224cd 100644
--- a/testing/docker/centos6/Dockerfile
+++ b/testing/docker/centos6/Dockerfile
@@ -3,8 +3,9 @@ ARG CTNG_UID
ARG CTNG_GID
RUN groupadd -g $CTNG_GID ctng
RUN useradd -d /home/ctng -m -g $CTNG_GID -u $CTNG_UID -s /bin/bash ctng
+RUN yum install -y epel-release
RUN yum install -y autoconf gperf bison flex texinfo help2man gcc-c++ libtool libtool-bin patch \
- ncurses-devel python-devel perl-Thread-Queue bzip2 git wget xz unzip
+ ncurses-devel python34-devel perl-Thread-Queue bzip2 git wget xz unzip
RUN wget -O /sbin/dumb-init https://github.com/Yelp/dumb-init/releases/download/v1.2.1/dumb-init_1.2.1_amd64
RUN chmod a+x /sbin/dumb-init
RUN echo 'export PATH=/opt/ctng/bin:$PATH' >> /etc/profile
diff --git a/testing/docker/centos7/Dockerfile b/testing/docker/centos7/Dockerfile
index b0f928d..0631c19 100644
--- a/testing/docker/centos7/Dockerfile
+++ b/testing/docker/centos7/Dockerfile
@@ -3,8 +3,10 @@ ARG CTNG_UID
ARG CTNG_GID
RUN groupadd -g $CTNG_GID ctng
RUN useradd -d /home/ctng -m -g $CTNG_GID -u $CTNG_UID -s /bin/bash ctng
+RUN yum install -y epel-release
RUN yum install -y autoconf gperf bison file flex texinfo help2man gcc-c++ libtool make patch \
- ncurses-devel python-devel perl-Thread-Queue bzip2 git wget which xz unzip
+ ncurses-devel python36-devel perl-Thread-Queue bzip2 git wget which xz unzip
+RUN ln -sf python36 /usr/bin/python3
RUN wget -O /sbin/dumb-init https://github.com/Yelp/dumb-init/releases/download/v1.2.1/dumb-init_1.2.1_amd64
RUN chmod a+x /sbin/dumb-init
RUN echo 'export PATH=/opt/ctng/bin:$PATH' >> /etc/profile
diff --git a/testing/docker/dmgr.sh b/testing/docker/dmgr.sh
index 1330867..825362a 100755
--- a/testing/docker/dmgr.sh
+++ b/testing/docker/dmgr.sh
@@ -3,11 +3,19 @@
# Run from the directory containing this script
cd `dirname $0`
+# Global return code (flags an error if any of the actions fail)
+global_rc=0
+
msg()
{
echo "INFO :: $*" >&2
}
+warn()
+{
+ echo "WARN :: $*" >&2
+}
+
error()
{
echo "ERROR :: $*" >&2
@@ -52,6 +60,8 @@ action_build()
{
local cntr=$1
+ msg "Cleaning up previous runs for ${cntr}"
+ do_cleanup ${cntr}/{build,install,xtools}
msg "Building Docker container for ${cntr}"
set -x
docker build --no-cache -t "ctng-${cntr}" --build-arg CTNG_GID=`id -g` --build-arg CTNG_UID=`id -u` "${cntr}"
@@ -81,6 +91,9 @@ _dckr()
else
$prefix su -l ctng
fi
+ if [ $? != 0 ]; then
+ global_rc=1
+ fi
}
# Run the test
@@ -91,8 +104,11 @@ action_install()
# The test assumes the top directory is bootstrapped, but clean.
msg "Setting up crosstool-NG in ${cntr}"
do_cleanup ${cntr}/build
- _dckr "${cntr}" /common-scripts/ctng-install && \
- _dckr "${cntr}" /common-scripts/ctng-test-basic
+ if ! _dckr "${cntr}" /common-scripts/ctng-install; then
+ warn "Installation failed"
+ elif ! _dckr "${cntr}" /common-scripts/ctng-test-basic; then
+ warn "Basic tests failed"
+ fi
}
# Run the test
@@ -164,3 +180,7 @@ case "${action}" in
usage "Unknown action ${action}."
;;
esac
+if [ "${global_rc}" != 0 ]; then
+ error "Some of the actions failed, see warnings above"
+fi
+exit ${global_rc}
diff --git a/testing/docker/fedora28/Dockerfile b/testing/docker/fedora29/Dockerfile
index 20363c9..65a0c60 100644
--- a/testing/docker/fedora28/Dockerfile
+++ b/testing/docker/fedora29/Dockerfile
@@ -1,10 +1,10 @@
-FROM fedora:28
+FROM fedora:29
ARG CTNG_UID
ARG CTNG_GID
RUN groupadd -g $CTNG_GID ctng
RUN useradd -d /home/ctng -m -g $CTNG_GID -u $CTNG_UID -s /bin/bash ctng
RUN yum install -y autoconf gperf bison file flex texinfo help2man gcc-c++ libtool make patch \
- ncurses-devel python-devel perl-Thread-Queue bzip2 git wget which xz unzip
+ ncurses-devel python3-devel perl-Thread-Queue bzip2 git wget which xz unzip
RUN wget -O /sbin/dumb-init https://github.com/Yelp/dumb-init/releases/download/v1.2.1/dumb-init_1.2.1_amd64
RUN chmod a+x /sbin/dumb-init
RUN echo 'export PATH=/opt/ctng/bin:$PATH' >> /etc/profile
diff --git a/testing/docker/mint19-amd64/Dockerfile b/testing/docker/mint19-amd64/Dockerfile
index 7a0e4ba..2b4f1ae 100644
--- a/testing/docker/mint19-amd64/Dockerfile
+++ b/testing/docker/mint19-amd64/Dockerfile
@@ -5,7 +5,7 @@ RUN groupadd -g $CTNG_GID ctng
RUN useradd -d /home/ctng -m -g $CTNG_GID -u $CTNG_UID -s /bin/bash ctng
RUN apt-get update
RUN apt-get install -y gcc gperf bison flex texinfo help2man make libncurses5-dev \
- python-dev autoconf automake libtool libtool-bin gawk wget
+ python3-dev autoconf automake libtool libtool-bin gawk wget
RUN wget -O /sbin/dumb-init https://github.com/Yelp/dumb-init/releases/download/v1.2.1/dumb-init_1.2.1_amd64
RUN chmod a+x /sbin/dumb-init
RUN echo 'export PATH=/opt/ctng/bin:$PATH' >> /etc/profile